import threading

from bot_api.api import Api
from bot_api.logging.api_logger import ApiLogger
from bot_core.configuration.feature_flags_enum import FeatureFlagsEnum
from bot_core.configuration.feature_flags_settings import FeatureFlagsSettings


class ApiThread(threading.Thread):

    def __init__(
            self,
            logger: ApiLogger,
            api: Api,
            feature_flags: FeatureFlagsSettings
    ):
        threading.Thread.__init__(self, daemon=True)

        self._logger = logger
        self._api = api

    def run(self) -> None:
        try:
            self._logger.trace(__name__, f'Try to start {type(self._api).__name__}')
            self._api.start()
        except Exception as e:
            self._logger.error(__name__, 'Start failed', e)
