from abc import abstractmethod

from cpl_core.application import StartupExtensionABC
from cpl_discord.service.discord_collection_abc import DiscordCollectionABC

from bot_core.configuration.feature_flags_enum import FeatureFlagsEnum


class ModuleABC(StartupExtensionABC):

    @abstractmethod
    def __init__(self, dc: DiscordCollectionABC, feature_flag: FeatureFlagsEnum):
        StartupExtensionABC.__init__(self)

        self._dc = dc
        self._feature_flag = feature_flag

    @property
    def feature_flag(self) -> FeatureFlagsEnum:
        return self._feature_flag
