import os

from cpl_cli.configuration import ProjectSettings, BuildSettings, WorkspaceSettings
from cpl_core.console import Console
from cpl_core.environment import ApplicationEnvironmentABC

from post_build.post_build_settings import PostBuildSettings


class RemoveConfig:

    def __init__(self, env: ApplicationEnvironmentABC, ws: WorkspaceSettings, project: ProjectSettings, build: BuildSettings, post_build: PostBuildSettings,):

        self._env = env
        self._workspace = ws
        self._project = project
        self._build = build
        self._post_build = post_build

    def remove(self):
        dist_path = os.path.abspath(os.path.join(
            self._env.working_directory,
            os.path.dirname(self._workspace.projects[self._project.name]),
            self._build.output_path,
            self._project.name,
            'build'
        ))

        for cfg_path in self._post_build.config_paths:
            config_path = os.path.join(
                dist_path,
                cfg_path
            )
            for r, d, f in os.walk(config_path):
                for file in f:
                    if file in self._post_build.keep_config:
                        continue

                    os.remove(os.path.abspath(os.path.join(config_path, file)))
